#pragma once
#define  PI 3.1415926535897932384626433832795
#include <math.h>
#include "windows.h"

class CASXTransform
{
protected:
	// members
	unsigned int NumBits;
	unsigned int nTransformLength;

	// subfunctions
	unsigned int NumberOfBitsNeeded();
	bool IsPowerOfTwo(unsigned int p_nX);
	unsigned int ReverseBits(unsigned int p_nIndex, unsigned int p_nBits);
	double Index_to_frequency(unsigned int p_nBaseFreq, unsigned int p_nSamples, unsigned int p_nIndex);
	double Index_to_frequency( unsigned NumSamples, unsigned Index );

public:
	CASXTransform(void);
	virtual ~CASXTransform(void);

	// set functions
	void setTransformLength(int f) { nTransformLength = f; NumBits = NumberOfBitsNeeded(); };
	// get functions
	int getTransformLength() { return nTransformLength; };
};

class CASXFFT: public CASXTransform
{
public:
	CASXFFT(void);
	~CASXFFT(void);

	// Fourier Transform Functions
	void fft(double *p_RealIn, double *p_RealOut, double *p_ImagOut);
	void ifft(double *p_RealIn, double *p_ImagIn, double *p_RealOut);
};